begin
  geof1  = addfile("/home/user/chensy3/data/zhangyue/WPSV391_2020-03/geo_em.d01.nc","r")
  lat1_sim   = geof1->XLAT_M
  lon1_sim   = geof1->XLONG_M
  lat1=lat1_sim(0,:,0)
  lon1=lon1_sim(0,0,:)

  nday=18
  plot=new(nday,graphic)
  plot_t=new(nday,graphic)


  path_S=" /home/csr4/zhangyue/wrfdata/wrfout/ETL_data/SWDRF/2020-03/"
  filename_S="wrfout_dust_SWC_2020_03*.nc"
  outfiles_S=systemfunc("ls " + path_S + filename_S)
  f_S = addfiles(outfiles_S +".nc","r")

  ListSetType(f_S,"join")
  S_TOP1 = f_S[:]->SWCTOP
  S_ATM1 = f_S[:]->SWCAMT
  S_BOT1 = f_S[:]->SWCBOT
  S_TOP  = dim_avg_n_Wrap(S_TOP1, 1)
  S_ATM  = dim_avg_n_Wrap(S_ATM1, 1)
  S_BOT  = dim_avg_n_Wrap(S_BOT1, 1)

  path_L=" /home/csr4/zhangyue/wrfdata/wrfout/ETL_data/LWDRF/2020-03/"
  filename_L="wrfout_dust_LWC_2020_03*.nc"
  outfiles_L=systemfunc("ls " + path_L + filename_L)
  f_L = addfiles(outfiles_L +".nc","r")

  ListSetType(f_L,"join")
  L_TOP1 = f_L[:]->LWCTOP
  L_ATM1 = f_L[:]->LWCATM
  L_BOT1 = f_L[:]->LWCBOT
  L_TOP  = dim_avg_n_Wrap(L_TOP1, 1)
  L_ATM  = dim_avg_n_Wrap(L_ATM1, 1)
  L_BOT  = dim_avg_n_Wrap(L_BOT1, 1)
  printVarSummary(L_BOT)


  path=" /home/user/chensy3/csr4/zhangyue/wrfdata/wrfout/ETL_data/dust_emission/2020-03/"
  filename="wrfout_dustemission_wind10_2020_03_1*.nc"
  outfiles=systemfunc("ls " +path+filename)
  f=addfiles(outfiles+".nc","r")
  ListSetType(f,"join")
  var = wrf_user_getvar(f(:),"DE",-1)
  printVarSummary(var)
 
  
  N_TOP = L_TOP + S_TOP
  N_ATM = L_ATM + S_ATM
  N_BOT = L_BOT + S_BOT
  printVarSummary(N_TOP)

  copy_VarMeta(var(0:5,:,:), N_TOP)
  copy_VarMeta(var(0:5,:,:), N_ATM)
  copy_VarMeta(var(0:5,:,:), N_BOT)
  ;N_TOP@units="W/m2"
  ;N_ATM@units="W/m2"
  ;N_BOT@units="W/m2"
  ;
  NN_TOP1=N_TOP(1,:,:)
  NN_TOP2=N_TOP(2,:,:) - N_TOP(1,:,:)
  NN_TOP3=N_TOP(3,:,:) - N_TOP(1,:,:)
  NN_TOP4=N_TOP(4,:,:) - N_TOP(1,:,:)
  NN_TOP5=N_TOP(5,:,:) - N_TOP(1,:,:)
  NN_TOP6=N_TOP(6,:,:) - N_TOP(1,:,:)

  NN_ATM1=N_ATM(1,:,:)
  NN_ATM2=N_ATM(2,:,:) - N_ATM(1,:,:)
  NN_ATM3=N_ATM(3,:,:) - N_ATM(1,:,:)
  NN_ATM4=N_ATM(4,:,:) - N_ATM(1,:,:)
  NN_ATM5=N_ATM(5,:,:) - N_ATM(1,:,:)
  NN_ATM6=N_ATM(6,:,:) - N_ATM(1,:,:)

  NN_BOT1=N_BOT(1,:,:)
  NN_BOT2=N_BOT(2,:,:) - N_BOT(1,:,:)
  NN_BOT3=N_BOT(3,:,:) - N_BOT(1,:,:)
  NN_BOT4=N_BOT(4,:,:) - N_BOT(1,:,:)
  NN_BOT5=N_BOT(5,:,:) - N_BOT(1,:,:)
  NN_BOT6=N_BOT(6,:,:) - N_BOT(1,:,:)

  printMinMax(NN_TOP1, False)
  printMinMax(NN_TOP2, False)
  printMinMax(NN_TOP3, False)
  printMinMax(NN_TOP4, False)
  printMinMax(NN_TOP5, False)
  printMinMax(NN_TOP6, False)
  print("+++++++++++++++++++")

  printMinMax(NN_ATM1, False)
  printMinMax(NN_ATM2, False)
  printMinMax(NN_ATM3, False)
  printMinMax(NN_ATM4, False)
  printMinMax(NN_ATM5, False)
  printMinMax(NN_ATM6, False)
  print("+++++++++++++++++++")

  printMinMax(NN_BOT1, False)
  printMinMax(NN_BOT2, False)
  printMinMax(NN_BOT3, False)
  printMinMax(NN_BOT4, False)
  printMinMax(NN_BOT5, False)
  printMinMax(NN_BOT6, False)
  print("+++++++++++++++++++")

  printMinMax(N_TOP(1,:,:), False)
  printMinMax(N_TOP(2,:,:), False)
  printMinMax(N_TOP(3,:,:), False)
  printMinMax(N_TOP(4,:,:), False)
  printMinMax(N_TOP(5,:,:), False)
  printMinMax(N_TOP(6,:,:), False)
  print("------------------")

  printMinMax(N_ATM(1,:,:), False)
  printMinMax(N_ATM(2,:,:), False)
  printMinMax(N_ATM(3,:,:), False)
  printMinMax(N_ATM(4,:,:), False)
  printMinMax(N_ATM(5,:,:), False)
  printMinMax(N_ATM(6,:,:), False)
  print("------------------")

  printMinMax(N_BOT(1,:,:), False)
  printMinMax(N_BOT(2,:,:), False)
  printMinMax(N_BOT(3,:,:), False)
  printMinMax(N_BOT(4,:,:), False)
  printMinMax(N_BOT(5,:,:), False)
  printMinMax(N_BOT(6,:,:), False)


loc=wrf_user_ll_to_ij(geof1, (/78,146/), (/25,51/), True)
Xstart=loc(0,0)
Xend=loc(0,1)
Ystart=loc(1,0)
Yend=loc(1,1)
  wks=gsn_open_wks("png", "d")
  res                   = True              ; plot mods desired
  res@Footer = False
  res@InitTime    = False
  res@FieldTitle=""
  res@NoHeaderFooter           = True            ; Switch headers and footers off
  res@cnFillPalette="temp_diff_18lev"


  res@cnFillOn              = True            ; color plot desired
  res@cnLinesOn             = False
  res@lbLabelFontHeightF=0.03
  res@lbBoxSeparatorLinesOn=False
  res@cnLineLabelsOn       = False
  res@pmLabelBarWidthF = 0.9
  res@pmLabelBarHeightF=0.3

  ;res@lbLabelBarOn=False
  ;res@cnLevelSelectionMode="ManualLevels"
  ;res@cnMinLevelValF=-5
  ;res@cnMaxLevelValF=5
  ;res@cnLevelSpacingF=1

  res1=res
  res1@cnLevelSelectionMode ="ExplicitLevels"
  Levels1 = (/-5,-4,-2,-1.5,-1,-0.5,-0.1,0.1,0.5,1,1.5,2,4,5/);
  res1@cnLevels = Levels1

  res2=res
  res2@cnLevelSelectionMode ="ExplicitLevels"
  Levels2 = (/-1.2,-1,-0.7,-0.5,-0.3,-0.2,-0.1,0.1,0.2,0.3,0.5,0.7,1,1.2/)
  res2@cnLevels = Levels2

  map_res = True
  map_res@gsnDraw=False
  map_res@gsnFrame=False
  map_res@mpDataSetName  = "/home/data/data-CSR4/chenyu/mapdata/Earth..4"
  map_res@mpDataBaseVersion="MediumRes"
  map_res@mpOutlineOn = True
  map_res@mpAreaMaskingOn       = True
  ;map_res@mpMaskAreaSpecifiers  = (/"China:states"/)
  ;map_res@mpOutlineSpecifiers = (/"China:states"/)
  map_res@mpNationalLineColor        = "black"
  map_res@mpCountyLineColor      = "black"
  map_res@mpProvincialLineColor  ="black"
  map_res@mpGeophysicalLineColor="black"
  map_res@mpGeophysicalLineThicknessF =2.5;3.5

  map_res@mpNationalLineThicknessF=1.5;3.5
  map_res@tmXBLabelFontHeightF=0.025
  map_res@tmYLLabelFontHeightF=0.025
  map_res@tmBorderThicknessF=3

  map_res@ZoomIn=True
  map_res@Xstart=Xstart
  map_res@Xend=Xend
  map_res@Ystart=Ystart
  map_res@Yend=Yend

  pltres=True
  pltres@PanelPlot = True      ; Indicate these plots are to be paneled.
  plot(0)=wrf_contour(geof1, wks, NN_TOP1(Ystart:Yend,Xstart:Xend), res1);N_TOP(1,:,:)
  plot_t(0)=wrf_map_overlays(geof1, wks, (/plot(0)/), pltres, map_res)
  plot(1)=wrf_contour(geof1, wks, NN_ATM1, res1);N_ATM(1,:,:)
  plot_t(1)=wrf_map_overlays(geof1, wks, (/plot(1)/), pltres, map_res)
  plot(2)=wrf_contour(geof1, wks, NN_BOT1, res1);N_BOT(1,:,:)
  plot_t(2)=wrf_map_overlays(geof1, wks, (/plot(2)/), pltres, map_res)

  plot(3)=wrf_contour(geof1, wks, NN_TOP2(Ystart:Yend,Xstart:Xend), res2);N_TOP(2,:,:)
  plot_t(3)=wrf_map_overlays(geof1,wks, (/plot(3)/), pltres, map_res)
  plot(4)=wrf_contour(geof1, wks, NN_ATM2, res2);N_ATM(2,:,:)
  plot_t(4)=wrf_map_overlays(geof1, wks, (/plot(4)/), pltres, map_res)
  plot(5)=wrf_contour(geof1, wks, NN_BOT2, res2);N_BOT(2,:,:)
  plot_t(5)=wrf_map_overlays(geof1, wks, (/plot(5)/), pltres, map_res)

  plot(6)=wrf_contour(geof1, wks, NN_TOP3(Ystart:Yend,Xstart:Xend), res2);N_TOP(3,:,:)
  plot_t(6)=wrf_map_overlays(geof1, wks, (/plot(6)/), pltres, map_res)
  plot(7)=wrf_contour(geof1, wks, NN_ATM3, res2);N_ATM(3,:,:)
  plot_t(7)=wrf_map_overlays(geof1, wks, (/plot(7)/), pltres, map_res)
  plot(8)=wrf_contour(geof1, wks, NN_BOT3, res2);N_BOT(3,:,:)
  plot_t(8)=wrf_map_overlays(geof1, wks, (/plot(8)/), pltres, map_res)

  plot(9)=wrf_contour(geof1, wks, NN_TOP4(Ystart:Yend,Xstart:Xend), res2);N_TOP(4,:,:)
  plot_t(9)=wrf_map_overlays(geof1, wks, (/plot(9)/), pltres, map_res)
  plot(10)=wrf_contour(geof1, wks, NN_ATM4, res2);N_ATM(4,:,:)
  plot_t(10)=wrf_map_overlays(geof1, wks, (/plot(10)/), pltres, map_res)
  plot(11)=wrf_contour(geof1, wks, NN_BOT4, res2);N_BOT(4,:,:)
  plot_t(11)=wrf_map_overlays(geof1, wks, (/plot(11)/), pltres, map_res)

  plot(12)=wrf_contour(geof1, wks, NN_TOP5(Ystart:Yend,Xstart:Xend), res2);N_TOP(5,:,:)
  plot_t(12)=wrf_map_overlays(geof1,wks, (/plot(12)/), pltres, map_res)
  plot(13)=wrf_contour(geof1, wks, NN_ATM5, res2);N_ATM(5,:,:)
  plot_t(13)=wrf_map_overlays(geof1, wks, (/plot(13)/), pltres, map_res)
  plot(14)=wrf_contour(geof1, wks, NN_BOT5, res2);N_BOT(5,:,:)
  plot_t(14)=wrf_map_overlays(geof1, wks, (/plot(14)/), pltres, map_res)

  plot(15)=wrf_contour(geof1, wks, NN_TOP6(Ystart:Yend,Xstart:Xend), res2);N_TOP(6,:,:)
  plot_t(15)=wrf_map_overlays(geof1, wks, (/plot(15)/), pltres, map_res)
  plot(16)=wrf_contour(geof1, wks, NN_ATM6, res2);N_ATM(6,:,:)
  plot_t(16)=wrf_map_overlays(geof1, wks, (/plot(16)/), pltres, map_res)
  plot(17)=wrf_contour(geof1, wks, NN_BOT6, res2);N_BOT(6,:,:)
  plot_t(17)=wrf_map_overlays(geof1, wks, (/plot(17)/), pltres, map_res)

  shp1="/home/user/chensy3/csr4/chenyu/NCL/china/mygeodata/china.shp"
  lnres1        = True
  lnres1@gsLineColor      ="black"
  lnres1@gsLineThicknessF = 2.5;3.5;          ; 2x thickness
  shp_plot1     = gsn_add_shapefile_polylines(wks,plot_t(0),shp1,lnres1)
  shp_plot2     = gsn_add_shapefile_polylines(wks,plot_t(1),shp1,lnres1)
  shp_plot3     = gsn_add_shapefile_polylines(wks,plot_t(2),shp1,lnres1)
  shp_plot4     = gsn_add_shapefile_polylines(wks,plot_t(3),shp1,lnres1)
  shp_plot5     = gsn_add_shapefile_polylines(wks,plot_t(4),shp1,lnres1)
  shp_plot6     = gsn_add_shapefile_polylines(wks,plot_t(5),shp1,lnres1)

  shp_plot7     = gsn_add_shapefile_polylines(wks,plot_t(6),shp1,lnres1)
  shp_plot8     = gsn_add_shapefile_polylines(wks,plot_t(7),shp1,lnres1)
  shp_plot9     = gsn_add_shapefile_polylines(wks,plot_t(8),shp1,lnres1)
  shp_plot10     = gsn_add_shapefile_polylines(wks,plot_t(9),shp1,lnres1)
  shp_plot11     = gsn_add_shapefile_polylines(wks,plot_t(10),shp1,lnres1)
  shp_plot12     = gsn_add_shapefile_polylines(wks,plot_t(11),shp1,lnres1)

  shp_plot13     = gsn_add_shapefile_polylines(wks,plot_t(12),shp1,lnres1)
  shp_plot14     = gsn_add_shapefile_polylines(wks,plot_t(13),shp1,lnres1)
  shp_plot15     = gsn_add_shapefile_polylines(wks,plot_t(14),shp1,lnres1)
  shp_plot16     = gsn_add_shapefile_polylines(wks,plot_t(15),shp1,lnres1)
  shp_plot17     = gsn_add_shapefile_polylines(wks,plot_t(16),shp1,lnres1)
  shp_plot18     = gsn_add_shapefile_polylines(wks,plot_t(17),shp1,lnres1)

  ;不做插值的情况的组图++++++
  ;pres                  = True
  ;pres@gsnMaximize=True
  ;pres@gsnPanelScalePlotIndex = 0
  ;pres@gsnPanelYWhiteSpacePercent = 0
  ;pres@gsnPanelXWhiteSpacePercent = 0
  ;pres@gsnPanelFigureStrings = (/"(DYN)","(DYN)","(DYN)","(DYN1)","(DYN1)","(DYN1)","(DYN2)","(DYN2)","(DYN2)","(DYN3)","(DYN3)","(DYN3)","(DYN4)","(DYN4)","(DYN4)","(DYN5)","(DYN5)","(DYN5)"/);
  ;pres@gsnPanelFigureStringsFontHeightF = 0.01
  ;pres@amOrthogonalPosF    =-0.5
  ;pres@amParallelPosF      =-0.5
  ;pres@amJust = "TopLeft"
  ;pres@gsnPanelLabelBar=True
  ;pres@lbBoxSeparatorLinesOn=False
  ;pres@lbLabelFontHeightF=0.015
  ;gsn_panel(wks,plot_t,(/6,3/),pres)
  ;+++++++++++++
pres                  = True
pres@gsnMaximize=True

pres@gsnPanelScalePlotIndex = 0
pres@gsnPanelYWhiteSpacePercent = 0
pres@gsnPanelXWhiteSpacePercent = 0

pres@gsnPanelFigureStrings = (/"(d)"/)
pres@gsnPanelFigureStringsFontHeightF = 0.035
pres@amOrthogonalPosF    =-0.5
pres@amParallelPosF      =-0.5
pres@amJust = "TopLeft"
gsn_panel(wks,plot_t(9),(/1,1/),pres)  ; the dust radiaive foricng at the top of the atmosphere could use plot_t(0),plot_t(3),plot_t(6),plot_t(9),plot_t(12),plot_t(15)
exit

pp=new(3,graphic)
ppl=new(15,graphic)

pp=plot_t(0:2)
ppl=plot_t(3:17)

pres                  = True
pres@gsnFrame         = False
pres@gsnPanelScalePlotIndex = 0
pres@gsnPanelYWhiteSpacePercent = 0
pres@gsnPanelXWhiteSpacePercent = 0
pres@gsnPanelFigureStringsFontHeightF = 0.008;0.015
pres@amJust = "TopLeft"
pres@gsnPanelCenter=True
pres@gsnPanelLabelBar=True
pres@lbBoxSeparatorLinesOn=False

;pres1=pres
;pres1@gsnPanelBottom=.05
;pres1@gsnPanelRight=0.99
;pres1@gsnPanelFigureStrings = (/"(DYN)","(DYN)","(DYN)"/)
;gsn_panel(wks,pp,(/1,3/),pres1)

pres2=pres
pres2@gsnPanelTop=.8
pres2@gsnPanelRight=0.99
pres2@gsnPanelFigureStrings = (/"(DYN)"/);(/"(DYN1)-(DYN)","(DYN1)-(DYN)","(DYN1)-(DYN)","(DYN2)-(DYN)","(DYN2)-(DYN)","(DYN2)-(DYN)","(DYN3)-(DYN)","(DYN3)-(DYN)","(DYN3)-(DYN)","(DYN4)-(DYN)","(DYN4)-(DYN)","(DYN4)-(DYN)","(DYN5)-(DYN)","(DYN5)-(DYN)","(DYN5)-(DYN)"/)
pres2@gsnPanelFigureStringsFontHeightF = 0.035
print("hello")
gsn_panel(wks,plot_t(0),(/1,1/),pres2)
frame(wks)

end